#!/usr/bin/perl -w

#   Copyright (C) 2006 David G. Jacobowitz 
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#


package matlibctrl;
use Exporter 'import';
@EXPORT_OK = qw(use_pari use_pdl);

## This file is all about choices and tradeoffs:
## 
## We can do our matrix math in one of three libraries, and as I
# am chronically indecisive, or just don't like my choices, I continue
# to code for all three. Here is where we choose which one we're really
# gonna use:
#
# Perl::PDL  -- fast, lean, and supposed support for sparse. Looks pretty
#               good except for no functions for determining collinearity
#               (rank) -- I may get around do writing that myself one day.
#               Oddly, it seems less accurate, too. :(
#
# libPARI    -- fash, leanish, and complete. Also, very high precision,
#               oh, but incredibly buggy and crashy. :(
#
# MatrixReal -- This library is written in perl and so is slow and 
#               memory intensive. It works fine, though, except for
#               dragging the computer into virtual memory hell for 
#               large datasets.


 my $pdl  = 1;
 my $pari = 0;


sub use_pdl  {
 return $pdl;
}
sub use_pari {
 return $pari && !$pdl;
};

1;
