#!/usr/bin/perl -w

#   Copyright (C) 2006 David G. Jacobowitz 
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

package safe_eval;
use Exporter 'import';

use Data::Dumper;

use misc qw(min max xtile randnorm);

@EXPORT_OK = qw(safe_eval);

my $last_eval_warn = "";

$SIG{__WARN__} = sub { $last_eval_warn = shift; };

sub safe_eval {
 my $estr  = shift;
 my $self  = shift;
 my $row   = shift; # true row
 my $lrow  = shift; # if row
 my $lrows = shift; # table of if rows (index 'if' row to true row)
 my $report = "";

 $last_eval_warn = "";
 # $estr = "print \" lrow_index \" . (\$lrow-1) . \" true_index \$lrows->[\$lrow-1]\\n\"; " . $estr;
 my $result = eval $estr;
 my $problem = ($@ || length($last_eval_warn) || !defined($result));
 if ($problem) {
  $result = "__undef";
  if ($@)              { $report .= "error; $@"; }
  if ($last_eval_warn) { $report .= "warn; $last_eval_warn"; }
  $report .= " eqn; $estr";
 }
# print "REPORT $report\n";
# print "RESULT $result EQN $estr\n";
 return ($result,$problem,$report);
}

1;

